﻿#Generated Form Function
Import-Module ActiveDirectory
function GenerateForm {
    ########################################################################
    # Code Generated By: SAPIEN Technologies PrimalForms (Community Edition) v1.0.9.0
    # Generated On: 20/10/2018 20:50
    # Generated By: Ian A Morris
    ########################################################################

    #region Import the Assemblies
    [reflection.assembly]::loadwithpartialname("System.Drawing") | Out-Null
    [reflection.assembly]::loadwithpartialname("System.Windows.Forms") | Out-Null
    #endregion

    #region Generated Form Objects
    $form1 = New-Object System.Windows.Forms.Form
    $txtUSERID = New-Object System.Windows.Forms.TextBox
    $progressBar1 = New-Object System.Windows.Forms.ProgressBar
    $buttEXIT = New-Object System.Windows.Forms.Button
    $buttEXPORT = New-Object System.Windows.Forms.Button
    $listBox1 = New-Object System.Windows.Forms.ListBox
    $dataGridView1 = New-Object System.Windows.Forms.DataGridView
    $buttGETGROUP = New-Object System.Windows.Forms.Button
    $label1 = New-Object System.Windows.Forms.Label
    $InitialFormWindowState = New-Object System.Windows.Forms.FormWindowState
    #endregion Generated Form Objects

    #----------------------------------------------
    #Generated Event Script Blocks
    #----------------------------------------------
    ##################################################################################################################
    function Load-ListBox {
        <#
        .SYNOPSIS
            This functions helps you load items into a ListBox or CheckedListBox.
    
        .DESCRIPTION
            Use this function to dynamically load items into the ListBox control.
    
        .PARAMETER  ListBox
            The ListBox control you want to add items to.
    
        .PARAMETER  Items
            The object or objects you wish to load into the ListBox's Items 
			collection.
    
        .PARAMETER  DisplayMember
            Indicates the property to display for the items in this control.
        
        .PARAMETER  Append
            Adds the item(s) to the ListBox without clearing the Items collection.
        
        .EXAMPLE
            Load-ListBox $ListBox1 "Red", "White", "Blue"
        
        .EXAMPLE
            Load-ListBox $listBox1 "Red" -Append
            Load-ListBox $listBox1 "White" -Append
            Load-ListBox $listBox1 "Blue" -Append
        
        .EXAMPLE
            Load-ListBox $listBox1 (Get-Process) "ProcessName"
    #>
        Param (
            [ValidateNotNull()]
            [Parameter(Mandatory = $true)]
            [System.Windows.Forms.ListBox]$ListBox,
            [ValidateNotNull()]
            [Parameter(Mandatory = $true)]
            $Items,
            [Parameter(Mandatory = $false)]
            [string]$DisplayMember,
            [switch]$Append
        )
        
        if (-not $Append) {
            $listBox.Items.Clear()    
        }
        
        if ($Items -is [System.Windows.Forms.ListBox+ObjectCollection]) {
            $listBox.Items.AddRange($Items)
        }
        elseif ($Items -is [Array]) {
            $listBox.BeginUpdate()
            foreach ($obj in $Items) {
                $listBox.Items.Add($obj)
            }
            $listBox.EndUpdate()
        }
        else {
            $listBox.Items.Add($Items)    
        }
    
        $listBox.DisplayMember = $DisplayMember    
    }
    ##################################################################################################################


    #region Report Path

    $PathOUT = $env:USERPROFILE
    $ReportPath = "$PathOut\Documents\Reports\Get Users Groups\"

    If (!(Test-Path $ReportPath)) {
        New-Item -ItemType Directory -Force -Path $ReportPath | Out-Null
    }
    #endregion Report Path

    #region Housekeeping
    # Housekeeping -  Delete files older than the $limit.

    $limit = (Get-Date).AddDays(-7)
    $ClearPath = $ReportPath
    Get-ChildItem -Path $ClearPath -Recurse -Force | Where-Object { !$_.PSIsContainer -and $_.CreationTime -lt $limit } | Remove-Item -Force

    #endregion Housekeeping

    ##################################################################################################################

    #Provide Custom Code for events specified in PrimalForms.
    $buttEXPORT_OnClick = 
    {
        #TODO: Place custom script here
        $progressbar1.Value = 100
        $progressBar1.Visible = $False
        $progressBar1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)
        $progressBar1.ForeColor = [System.Drawing.Color]::FromArgb(255, 0, 0, 255)
        $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 176, 224, 230)
        $listBox1.ForeColor = [System.Drawing.Color]::Black
        $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 176, 224, 230)
        $datagridview1.DataSource = $null
        $ListBox1.Items.Clear()
        Load-ListBox $ListBox1 "Gathering Group Membership Information..."
        Start-Sleep -Seconds 2
        $buttEXPORT.Enabled = $False		
        $buttEXIT.Enabled = $False
        $buttGETGROUP.Enabled = $False

        $UserID = $txtUSERID.Text

        if ($UserID -eq "" -or $UserID -eq "....ENTER USER ID...." ) {

            $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
            $listBox1.ForeColor = [System.Drawing.Color]::White
            $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
            Load-ListBox $ListBox1 "No USERID Entered. Please enter a USERID"
   
            $buttEXIT.Enabled = $true
            $buttEXPORT.Enabled = $true
            $buttGETGROUP.Enabled = $true
    
        }
        else {

            $ExportRep = "$ReportPath$UserID - Group Report-{0:yyyy-MM-dd_HH.mm.ss}.csv" -f (get-date)
            If (get-aduser -F { SamAccountName -eq $UserID })
            {
                $Groups = [System.Collections.ArrayList](Get-ADPrincipalGroupMembership $UserID | Get-ADGroup -Properties * | Select Name, SamAccountName, Description, DistinguishedName | Sort-Object Name) #| Export-Csv -Path $ExportRep -Append -NoTypeInformation)

                If ($Groups -eq $null) {
                    Load-ListBox $listBox1 "WARNING : No Groups found!.
                                                   You may not have the permission to view this accounts details. 
                                                   Contact your Administrator"
                }
    
                Else {
                    $Groups | Export-Csv -Path $ExportRep -Append -NoTypeInformation
                }


                $datagridview1.DataSource = $Groups
                $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)

                $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)
                Load-ListBox -ListBox $listBox1 "Exporting All Group Membership Information"
                Load-ListBox -ListBox $listBox1 "for Account $UserID" -Append
                $buttEXPORT.Enabled = $True		
                $buttEXIT.Enabled = $True
                $buttGETGROUP.Enabled = $True
                $progressBar1.Visible = $True
                Invoke-Item -Path $ExportRep

            }
            Else {
                $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
                $listBox1.ForeColor = [System.Drawing.Color]::White
                $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
                Load-ListBox -ListBox $listBox1 " WARNING : The User ID $UserID cannot be found."
                Load-ListBox -ListBox $listBox1 " WARNING : Check details and retry." -Append
                $buttEXPORT.Enabled = $True		
                $buttEXIT.Enabled = $True
                $buttGETGROUP.Enabled = $True
                $progressBar1.Visible = $true
                $progressBar1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
                $progressBar1.ForeColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
            }
        }
    }

    $buttGETGROUP_OnClick = 
    {
        #TODO: Place custom script here
        $progressbar1.Value = 100
        $progressBar1.Visible = $False
        $progressBar1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)
        $progressBar1.ForeColor = [System.Drawing.Color]::FromArgb(255, 0, 0, 255)
        $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 176, 224, 230)
        $listBox1.ForeColor = [System.Drawing.Color]::Black
        $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 176, 224, 230)
        $datagridview1.DataSource = $null
        $ListBox1.Items.Clear()
        Load-ListBox $ListBox1 "Gathering Group Membership Information for $UserID"
        Start-Sleep -Seconds 2
        $buttEXPORT.Enabled = $False		
        $buttEXIT.Enabled = $False
        $buttGETGROUP.Enabled = $False

        $UserID = $txtUSERID.Text

        if ($UserID -eq "" -or $UserID -eq "....ENTER USER ID...." ) {

            $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
            $listBox1.ForeColor = [System.Drawing.Color]::White
            $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
            Load-ListBox $ListBox1 "No USERID Entered. Please enter a USERID"
   
            $buttEXIT.Enabled = $true
            $buttEXPORT.Enabled = $true
            $buttGETGROUP.Enabled = $true
   
        }
        else {

    
            If (get-aduser -F { SamAccountName -eq $UserID })
            {
                Load-ListBox $ListBox1 "Gathering Group Membership Information For $UserID"
                $Groups = [System.Collections.ArrayList](Get-ADPrincipalGroupMembership $UserID | Get-ADGroup -Properties * | Select Name, SamAccountName, Description, DistinguishedName | Sort-Object Name)
                $dataGridView1.DataSource = $Groups
                $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)

                $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)
                Load-ListBox -ListBox $listBox1 "Gathered All Group Membership Information"
                Load-ListBox -ListBox $listBox1 "for Account $UserID" -Append
                $buttEXPORT.Enabled = $True		
                $buttEXIT.Enabled = $True
                $buttGETGROUP.Enabled = $True
                $progressBar1.Visible = $True

            }
            Else {
                $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
                $listBox1.ForeColor = [System.Drawing.Color]::White
                $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
                Load-ListBox -ListBox $listBox1 " WARNING : The User ID $UserID cannot be found."
                Load-ListBox -ListBox $listBox1 " WARNING : Check details and retry." -Append
                $buttEXPORT.Enabled = $True		
                $buttEXIT.Enabled = $True
                $buttGETGROUP.Enabled = $True
                $progressBar1.Visible = $true
                $progressBar1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
                $progressBar1.ForeColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)
            }
        }
    }

    $buttEXIT_OnClick = 
    {
        #TODO: Place custom script here
        $form1.Close()

    }

    $OnLoadForm_StateCorrection =
    { #Correct the initial state of the form to prevent the .Net maximized form issue
        $form1.WindowState = $InitialFormWindowState
    }

    #----------------------------------------------
    #region Generated Form Code
    $form1.BackColor = [System.Drawing.Color]::FromArgb(255, 192, 192, 192)
    $form1.CancelButton = $buttEXIT
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 511
    $System_Drawing_Size.Width = 438
    $form1.ClientSize = $System_Drawing_Size
    $form1.DataBindings.DefaultDataSourceUpdateMode = 0
    $form1.FormBorderStyle = 2
    $ErrorActionPreference = "SilentlyContinue"
    $form1.Icon = [System.Drawing.Icon]::ExtractAssociatedIcon('C:\Program Files (x86)\MoZZaToolkit\Get Users Groups\Media\logo_bcl_ooC_icon.ico')
    $ErrorActionPreference = "Continue"
    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 141
    $System_Drawing_Point.Y = 0
    $form1.Location = $System_Drawing_Point
    $form1.MaximizeBox = $False
    $form1.Name = "form1"
    $form1.StartPosition = 1
    $form1.Text = "BCL Get Users Groups v3.0"
    #$form1.TransparencyKey = [System.Drawing.Color]::FromArgb(255,255,255,255)

    $txtUSERID.CharacterCasing = 1
    $txtUSERID.DataBindings.DefaultDataSourceUpdateMode = 0
    $txtUSERID.Font = New-Object System.Drawing.Font("Microsoft Sans Serif", 9.75, 0, 3, 0)
    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 65
    $System_Drawing_Point.Y = 36
    $txtUSERID.Location = $System_Drawing_Point
    $txtUSERID.Name = "txtUSERID"
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 20
    $System_Drawing_Size.Width = 308
    $txtUSERID.Size = $System_Drawing_Size
    $txtUSERID.TabIndex = 2
    $txtUSERID.TextAlign = 2
    $txtUSERID.Text = "....Enter USER ID...."

    $form1.Controls.Add($txtUSERID)

    $progressBar1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)
    $progressBar1.DataBindings.DefaultDataSourceUpdateMode = 0
    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 13
    $System_Drawing_Point.Y = 477
    $progressBar1.Location = $System_Drawing_Point
    $progressBar1.Name = "progressBar1"
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 23
    $System_Drawing_Size.Width = 413
    $progressBar1.Size = $System_Drawing_Size
    $progressBar1.TabIndex = 7
    $progressBar1.Visible = $False

    $form1.Controls.Add($progressBar1)

    $buttEXIT.BackColor = [System.Drawing.Color]::FromArgb(255, 128, 128, 128)

    $buttEXIT.DataBindings.DefaultDataSourceUpdateMode = 0
    $buttEXIT.DialogResult = 2
    $buttEXIT.ForeColor = [System.Drawing.Color]::FromArgb(255, 255, 0, 0)

    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 305
    $System_Drawing_Point.Y = 75
    $buttEXIT.Location = $System_Drawing_Point
    $buttEXIT.Name = "buttEXIT"
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 39
    $System_Drawing_Size.Width = 121
    $buttEXIT.Size = $System_Drawing_Size
    $buttEXIT.TabIndex = 4
    $buttEXIT.Text = "Exit"
    $buttEXIT.UseVisualStyleBackColor = $False
    $buttEXIT.add_Click($buttEXIT_OnClick)

    $form1.Controls.Add($buttEXIT)

    $buttEXPORT.BackColor = [System.Drawing.Color]::FromArgb(255, 128, 128, 128)

    $buttEXPORT.DataBindings.DefaultDataSourceUpdateMode = 0
    $buttEXPORT.ForeColor = [System.Drawing.Color]::FromArgb(255, 0, 255, 0)

    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 159
    $System_Drawing_Point.Y = 75
    $buttEXPORT.Location = $System_Drawing_Point
    $buttEXPORT.Name = "buttEXPORT"
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 39
    $System_Drawing_Size.Width = 121
    $buttEXPORT.Size = $System_Drawing_Size
    $buttEXPORT.TabIndex = 3
    $buttEXPORT.Text = "Export Results"
    $buttEXPORT.UseVisualStyleBackColor = $False
    $buttEXPORT.add_Click($buttEXPORT_OnClick)

    $form1.Controls.Add($buttEXPORT)


    $listBox1.BackColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)
    $listBox1.DataBindings.DefaultDataSourceUpdateMode = 0
    $listBox1.FormattingEnabled = $True
    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 12
    $System_Drawing_Point.Y = 401
    $listBox1.Location = $System_Drawing_Point
    $listBox1.Name = "listBox1"
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 69
    $System_Drawing_Size.Width = 414
    $listBox1.Size = $System_Drawing_Size
    $listBox1.TabIndex = 6

    $form1.Controls.Add($listBox1)

    $System_Windows_Forms_DataGridViewCellStyle_14 = New-Object System.Windows.Forms.DataGridViewCellStyle
    $System_Windows_Forms_DataGridViewCellStyle_14.BackColor = [System.Drawing.Color]::FromArgb(255, 224, 224, 224)
    $dataGridView1.AlternatingRowsDefaultCellStyle = $System_Windows_Forms_DataGridViewCellStyle_14
    $dataGridView1.AutoSizeColumnsMode = 6
    $dataGridView1.BackgroundColor = [System.Drawing.Color]::FromArgb(255, 255, 255, 255)
    $dataGridView1.ClipboardCopyMode = 2
    $dataGridView1.DataBindings.DefaultDataSourceUpdateMode = 0
    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 13
    $System_Drawing_Point.Y = 133
    $dataGridView1.Location = $System_Drawing_Point
    $dataGridView1.Name = "dataGridView1"
    $dataGridView1.RowHeadersWidthSizeMode = 3
    $dataGridView1.SelectionMode = 0
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 261
    $System_Drawing_Size.Width = 413
    $dataGridView1.Size = $System_Drawing_Size
    $dataGridView1.TabIndex = 5

    $form1.Controls.Add($dataGridView1)

    $buttGETGROUP.BackColor = [System.Drawing.Color]::FromArgb(255, 128, 128, 128)

    $buttGETGROUP.DataBindings.DefaultDataSourceUpdateMode = 0
    $buttGETGROUP.ForeColor = [System.Drawing.Color]::FromArgb(255, 0, 255, 0)

    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 13
    $System_Drawing_Point.Y = 75
    $buttGETGROUP.Location = $System_Drawing_Point
    $buttGETGROUP.Name = "buttGETGROUP"
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 39
    $System_Drawing_Size.Width = 121
    $buttGETGROUP.Size = $System_Drawing_Size
    $buttGETGROUP.TabIndex = 1
    $buttGETGROUP.Text = "Get Groups"
    $buttGETGROUP.UseVisualStyleBackColor = $False
    $buttGETGROUP.add_Click($buttGETGROUP_OnClick)

    $form1.Controls.Add($buttGETGROUP)

    $label1.DataBindings.DefaultDataSourceUpdateMode = 0
    $label1.Font = New-Object System.Drawing.Font("Microsoft Sans Serif", 8.25, 1, 3, 1)
    $label1.ForeColor = [System.Drawing.Color]::FromArgb(255, 0, 0, 255)

    $System_Drawing_Point = New-Object System.Drawing.Point
    $System_Drawing_Point.X = 173
    $System_Drawing_Point.Y = 10
    $label1.Location = $System_Drawing_Point
    $label1.Name = "label1"
    $System_Drawing_Size = New-Object System.Drawing.Size
    $System_Drawing_Size.Height = 23
    $System_Drawing_Size.Width = 92
    $label1.Size = $System_Drawing_Size
    $label1.TabIndex = 0
    $label1.Text = "Enter User ID"

    $form1.Controls.Add($label1)

    #endregion Generated Form Code

    #Save the initial state of the form
    $InitialFormWindowState = $form1.WindowState
    #Init the OnLoad event to correct the initial state of the form
    $form1.add_Load($OnLoadForm_StateCorrection)
    #Show the Form
    $form1.ShowDialog() | Out-Null

} #End Function

#Call the Function
GenerateForm
